// CvO
unit Unit0044;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Menus, ComCtrls,
  UnitIni, UnitFunc, UnitGraph, UnitGVar,
  Unit0044a, Unit0044b, Unit0044c, Unit0044d, Unit0044e ;

type
  TFmMain = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    MnuExit: TMenuItem;
    Show1: TMenuItem;
    MnuWindDisp: TMenuItem;
    N1: TMenuItem;
    MnuMoMove1: TMenuItem;
    MnuMoMove2: TMenuItem;
    MnuMoMove3: TMenuItem;
    Panel1: TPanel;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Panel2: TPanel;
    PaintBox1: TPaintBox;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    Panel3: TPanel;
    Panel4: TPanel;
    StatusBar1: TStatusBar;
    LabelA1: TLabel;
    LabelA2: TLabel;
    LabelA3: TLabel;
    MnuFileNew: TMenuItem;
    N2: TMenuItem;
    S1: TMenuItem;
    MnuSetLayer: TMenuItem;
    MnuSetLStyle: TMenuItem;
    MnuSetColor: TMenuItem;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    ComboBox2: TComboBox;
    Label3: TLabel;
    ComboBox3: TComboBox;
    Label4: TLabel;
    ComboBox4: TComboBox;
    ColorDialog1: TColorDialog;
    procedure FormShow(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure MnuFileNewClick(Sender: TObject);
    procedure MnuExitClick(Sender: TObject);
    procedure MnuWindDispClick(Sender: TObject);
    procedure MnuMoMove1Click(Sender: TObject);
    procedure MnuMoMove2Click(Sender: TObject);
    procedure MnuMoMove3Click(Sender: TObject);
    procedure MnuSetLayerClick(Sender: TObject);
    procedure MnuSetColorClick(Sender: TObject);
    procedure MnuSetLStyleClick(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ComboBox2Click(Sender: TObject);
  private
    { Private 錾 }
    Fmode : Integer ;         // @\[h
    FBx,FBy : Double ;        // @\s̍ۂɋLwW
    RBflag : Boolean ;        // o[oh\tO True:\ False:\
    RBx1,RBy1 : Integer ;     // o[ohJn_
    RBx2,RBy2 : Integer ;     // o[ohI_
    DRGx1,DRGy1 : Integer ;   // hbOJn_
    DRGx2,DRGy2 : Integer ;   // hbOI_
    DRGmode : Integer ;       // hbO[h 0:ړ 1:g(SHIFT) 2:k(CTRL)
    DRGflag : Boolean ;       // hbOǂ̃tO
    DRGRBflag : Boolean ;     // hbÕo[oh\tO
    procedure GRBLINE(rx1,ry1,rx2,ry2:Integer); // o[oh`
    procedure GRBBOX(rx1,ry1,rx2,ry2:Integer);  // o[oh``
    procedure GRBERASE;   // o[oh
    procedure MouseClick(X,Y,M:Integer);
    function  MouseSnap(var x,y:double):Boolean;
    procedure DatAttribSet(n:integer);
  public
    { Public 錾 }
    procedure GCLS ;    // ʃNA
    procedure GDRAW ;   // ʍ}
    procedure GALDRAW ; // ʕ\
    procedure GREDRAW ; // ʍč}
    procedure COM_DISPMOVE ;     // ʈړ
    procedure COM_DISPZOOM1 ;    // Q{\
    procedure COM_DISPZOOM2 ;    // 1/2{k
    procedure COM_DRAWLINE1 ;    // }
  end;

var
  FmMain: TFmMain;

implementation

{$R *.dfm}

// 
procedure TFmMain.FormShow(Sender: TObject);
var
   p1,p2 : double ;
   i : integer ;
   inif,s : String ;
begin
   // eϐ̏
   Fmode := 0 ;
   RBflag := False ;
   FBx := 0.0;
   FBy := 0.0;
   DRGflag := False ;
   DRGRBflag := False ;
   Dat_N := 0 ;      // f[^
   ZA_MinX := 0.0 ;
   ZA_MinY := 0.0 ;
   ZA_MaxX := 0.0 ;
   ZA_MaxY := 0.0 ;

   PA_x := 1189.0;
   PA_y :=  841.0;
   SC_x := PaintBox1.Width ;
   SC_y := PaintBox1.Height ;
   p1 := SC_x / PA_x ;
   p2 := SC_y / PA_y ;
   if (p1 < p2) then MM_dot := p1 else MM_dot := p2 ;
   MM_dotmax := MM_dot ;
   IN_move := 50 ;   // ʈړ(ini/inp)
   IN_scale:= 1.0 ;  // Cӊg(ini/inp)
   GALDRAW ;         // --- ʕ` ---

   // FݒE
   ColTblN := 30 ;
   SetLength(ColTbl, ColTblN);
   ColTbl[ 0].nam := 'F';   ColTbl[ 0].val := clBlue;
   ColTbl[ 1].nam := 'ԐF';   ColTbl[ 1].val := clRed;
   ColTbl[ 2].nam := 'F';   ColTbl[ 2].val := clFuchsia;
   ColTbl[ 3].nam := 'ΐF';   ColTbl[ 3].val := clLime;
   ColTbl[ 4].nam := 'F';   ColTbl[ 4].val := clAqua;
   ColTbl[ 5].nam := 'F';   ColTbl[ 5].val := clYellow;
   ColTbl[ 6].nam := 'F';   ColTbl[ 6].val := clBlack;
   ColTbl[ 7].nam := 'DF';   ColTbl[ 7].val := clSilver;
   ColTbl[ 8].nam := 'ZF'; ColTbl[ 8].val := clNavy;
   ColTbl[ 9].nam := 'ZԐF'; ColTbl[ 9].val := clMaroon;
   ColTbl[10].nam := 'ZF'; ColTbl[10].val := clPurple;
   ColTbl[11].nam := 'ZΐF'; ColTbl[11].val := clGreen;
   ColTbl[12].nam := 'ZF'; ColTbl[12].val := clTeal;
   ColTbl[13].nam := 'ZF'; ColTbl[13].val := clOlive;
   ColTbl[14].nam := 'ZDF'; ColTbl[14].val := clGray;
   for i:=1 to ColTblN-15 do begin
      ColTbl[14+i].nam := 'gF'+IntToStr(i);
      ColTbl[14+i].val := clBlack;
   end;

   // ݒE
   LinTblN := 1 ;
   SetLength(LinTbl, LinTblN);
   with LinTbl[0] do begin
      no  := 0 ;
      nam := '';
      val := 0 ;
      n   := 0 ;
      ptn := nil ;
      cnt := 0 ;
   end;

   // CݒE
   LayTblN := 1 ;
   SetLength(LayTbl, LayTblN);
   with LayTbl[0] do begin
      no  := 0 ;
      nam := '0';
      act := True ;
      dsp := True ;
      sc  := 1.0 ;
      scs := '1/1' ;
      dc  := 6 ;
      dcs := 'F' ;
      dl  := 0 ;
      dls := '' ;
      lsc := 1.0 ;
      wid := 0.0 ;
      cnt := 0 ;
   end;

   { INI Fileǂ }
   AppPath := ExtractFilePath(Application.ExeName);
   inif := AppPath + 'test.ini' ;
	if (ReadIniFile('Form','F01_X',s,inif,9)) then FmMain.Left   := SInt(s);
	if (ReadIniFile('Form','F01_Y',s,inif,9)) then FmMain.Top    := SInt(s);
	if (ReadIniFile('Form','F01_W',s,inif,9)) then FmMain.Width  := SInt(s);
	if (ReadIniFile('Form','F01_H',s,inif,9)) then FmMain.Height := SInt(s);
	if (ReadIniFile('Form','F02_X',s,inif,9)) then FmWindowPal.Left:= SInt(s);
	if (ReadIniFile('Form','F02_Y',s,inif,9)) then FmWindowPal.Top := SInt(s);
   for i:=16 to ColTblN do begin
	   if (ReadIniFile('ColTbl','N'+IntToStr(i),s,inif,82)) then ColTbl[i-1].nam := s;
	   if (ReadIniFile('ColTbl','V'+IntToStr(i),s,inif,82)) then ColTbl[i-1].val := SInt(s);
   end;

   { eR|[lg̐ݒ }
   with ComboBox1 do begin
      Items.Clear;
      Items.Add('0');
      ItemIndex := 0;
   end;
   with ComboBox2 do begin
      Items.Clear;
      Items.Add('CF');
      for i:=0 to ColTblN-1 do begin
         Items.Add(ColTbl[i].nam);
      end;
      Items.Add('̑');
      Items.Add('$00000000');
      ItemIndex := 0;
   end;
   with ComboBox3 do begin
      Items.Clear;
      Items.Add('C');
      Items.Add('');
      ItemIndex := 0;
   end;
   with ComboBox4 do begin
      Items.Clear;
      Items.Add('C');
      Items.Add('0');
      Items.Add('0.1');
      Items.Add('0.3');
      Items.Add('0.5');
      Items.Add('0.8');
      Items.Add('1.0');
      Items.Add('1.2');
      Items.Add('1.5');
      Items.Add('1.8');
      Items.Add('2.0');
      Items.Add('2.5');
      Items.Add('3.0');
      ItemIndex := 0;
   end;
end;

// vOI
procedure TFmMain.FormClose(Sender: TObject; var Action: TCloseAction);
var
   i : integer ;
   i1,i2,i3,i4,i5,i6 : integer ;
   inif : String ;
begin
   Dat := nil ;         // f[^̈

   { INI File }
   inif := AppPath + 'test.ini' ;
	i1 := FmMain.Left ;
   i2 := FmMain.Top ;
	i3 := FmMain.Width ;
   i4 := FmMain.Height ;
	i5 := FmWindowPal.Left ;
   i6 := FmWindowPal.Top ;
	try
	   WriteIniFile('Form','F01_X',IntToStr(i1) ,inif);
   	WriteIniFile('Form','F01_Y',IntToStr(i2) ,inif);
	   WriteIniFile('Form','F01_W',IntToStr(i3) ,inif);
   	WriteIniFile('Form','F01_H',IntToStr(i4) ,inif);
	   WriteIniFile('Form','F02_X',IntToStr(i5) ,inif);
   	WriteIniFile('Form','F02_Y',IntToStr(i6) ,inif);
      for i:=16 to ColTblN do begin
      	WriteIniFile('ColTbl','N'+IntToStr(i),ColTbl[i-1].nam,inif);
      	WriteIniFile('ColTbl','V'+IntToStr(i),IntToStr(ColTbl[i-1].val),inif);
      end;
	except
   	;
   end;

   // ef[^iIzj̉
   ColTbl := nil ;                  // Fݒe[u
   for i:=0 to LinTblN-1 do begin   // ݒe[u
      LinTbl[i].ptn := nil ;
   end;
   LinTbl := nil ;
   LayTbl := nil ;
end;

// ʂNA
procedure TFmMain.GCLS ;
begin
   G_CLS(PaintBox1.Canvas,0,0,SC_x,SC_y);
end;

// ʂ}
procedure TFmMain.GDRAW ;
begin
   GL_PAPERFRAME(PaintBox1.Canvas); // pg}
   GL_ALLDAT(PaintBox1.Canvas);     // Svf}
   //
   RBx1 := Round( ( FBx - WD_x1 ) * MM_dot );   // ČvZ
   RBy1 := Round(-( FBy - WD_y2 ) * MM_dot );
   if (RBflag) then begin
      RBflag := False ; // o[oh͏Ă̂
   end;
end;

// ʕ\
procedure TFmMain.GALDRAW ;
begin
   GCLS ;   // ʂNA
   MM_dot := MM_dotmax ;
   WD_x1 := - SC_x / 2.0 / MM_dot ;
   WD_y1 := - SC_y / 2.0 / MM_dot ;
   WD_x2 :=   SC_x / 2.0 / MM_dot ;
   WD_y2 :=   SC_y / 2.0 / MM_dot ;
   LabelA1.Caption := '( '+FloatToStr(WD_x1)+' , '+FloatToStr(WD_y1)+' )';
   LabelA2.Caption := '( '+FloatToStr(WD_x2)+' , '+FloatToStr(WD_y2)+' )';
   GDRAW ;  // ʂ}
   ScrollBar1.Enabled := False ;
   ScrollBar1.Position := 0;
   ScrollBar1.Enabled := True ;
   ScrollBar2.Enabled := False ;
   ScrollBar2.Position := 0;
   ScrollBar2.Enabled := True ;
end;

// ʂč}
procedure TFmMain.GREDRAW ;
begin
   GCLS ;   // ʂNA
   LabelA1.Caption := '( '+FloatToStr(WD_x1)+' , '+FloatToStr(WD_y1)+' )';
   LabelA2.Caption := '( '+FloatToStr(WD_x2)+' , '+FloatToStr(WD_y2)+' )';
   GDRAW ;  // ʂ}
end;

// o[oh`
procedure TFmMain.GRBLINE(rx1,ry1,rx2,ry2:Integer);
begin
   GRB_LINE(PaintBox1.Canvas,rx1,ry1,rx2,ry2);
end;

// o[oh``
procedure TFmMain.GRBBOX(rx1,ry1,rx2,ry2:Integer);
begin
   GRB_BOX(PaintBox1.Canvas,rx1,ry1,rx2,ry2);
end;

// o[oh
procedure TFmMain.GRBERASE;
begin
   if (RBflag) then begin
      Case (Fmode) of
      101:begin
            GRBLINE(RBx1,RBy1,RBx2,RBy2);
         end;
      end;
      RBflag := False ;
   end;
end;

// ʂĕ`
procedure TFmMain.PaintBox1Paint(Sender: TObject);
begin
   GREDRAW ;  // ʍč}
end;

// ʂTCYꂽČvZ
procedure TFmMain.FormResize(Sender: TObject);
var
   p1,p2 : double ;
begin
   SC_x := PaintBox1.Width ;
   SC_y := PaintBox1.Height ;
   p1 := SC_x / PA_x ;
   p2 := SC_y / PA_y ;
   if (p1 < p2) then MM_dotmax := p1 else MM_dotmax := p2 ;
   WD_x1 := - SC_x / 2.0 / MM_dot ;
   WD_y1 := - SC_y / 2.0 / MM_dot ;
   WD_x2 :=   SC_x / 2.0 / MM_dot ;
   WD_y2 :=   SC_y / 2.0 / MM_dot ;
   // ̌PaintBoxOnPaintCxg܂̂
   // č}͂ɔC܂
end;

// ========== ========== ========== ==========
//                 j[
// ========== ========== ========== ==========

// j[bt@CbVK쐬
procedure TFmMain.MnuFileNewClick(Sender: TObject);
var
   p1,p2 : double ;
begin
   FmFileNew.ShowModal ;
   if (FmFileNew.OKflag) then begin
      Dat := nil ;         // f[^̈
      Dat_N := 0 ;
      PA_x := FmFileNew.SS_P1 ;
      PA_y := FmFileNew.SS_P2 ;
      p1 := SC_x / PA_x ;
      p2 := SC_y / PA_y ;
      if (p1 < p2) then MM_dot := p1 else MM_dot := p2 ;
      MM_dotmax := MM_dot ;
      GALDRAW;
   end;
end;

// j[bt@CbI
procedure TFmMain.MnuExitClick(Sender: TObject);
begin
   close ;
end;

// j[b\bEChEpbg
procedure TFmMain.MnuWindDispClick(Sender: TObject);
begin
   FmWindowPal.Show ;
end;

// j[b\b}EXŉʈړ
procedure TFmMain.MnuMoMove1Click(Sender: TObject);
begin
   COM_DISPMOVE ;
end;

// j[b\b}EXłQ{g
procedure TFmMain.MnuMoMove2Click(Sender: TObject);
begin
   COM_DISPZOOM1 ;
end;

// j[b\b}EX1/2{k
procedure TFmMain.MnuMoMove3Click(Sender: TObject);
begin
   COM_DISPZOOM2 ;
end;

// j[bݒbC
procedure TFmMain.MnuSetLayerClick(Sender: TObject);
var
   i,j : integer ;
   sc : Double ;
begin
   FmSetLayer.ShowModal ;

   with ComboBox1 do begin
      Items.Clear;
      for i:=0 to LayTblN-1 do begin
         Items.Add(LayTbl[i].nam);
      end;
      ItemIndex := FmSetLayer.SS_P1 ;
   end;

   // }`͈͍ČvZ
   for i:=0 to Dat_N-1 do begin
      sc:= 1.0;
      for j:=0 to LayTblN-1 do begin
         if (LayTbl[j].no = Dat[i].lay) then begin
            sc := LayTbl[j].sc;
            break;
         end;
      end;
      if (i = 0) then begin
         ZA_MinX := Dat[i].x1 *sc;
         ZA_MinY := Dat[i].y1 *sc;
         ZA_MaxX := Dat[i].x1 *sc;
         ZA_MaxY := Dat[i].y1 *sc;
      end
      else begin
         if (ZA_MinX > Dat[i].x1 *sc) then ZA_MinX:=Dat[i].x1 *sc;
         if (ZA_MinX > Dat[i].x2 *sc) then ZA_MinX:=Dat[i].x2 *sc;
         if (ZA_MinY > Dat[i].y1 *sc) then ZA_MinY:=Dat[i].y1 *sc;
         if (ZA_MinY > Dat[i].y2 *sc) then ZA_MinY:=Dat[i].y2 *sc;
         if (ZA_MaxX < Dat[i].x1 *sc) then ZA_MaxX:=Dat[i].x1 *sc;
         if (ZA_MaxX < Dat[i].x2 *sc) then ZA_MaxX:=Dat[i].x2 *sc;
         if (ZA_MaxY < Dat[i].y1 *sc) then ZA_MaxY:=Dat[i].y1 *sc;
         if (ZA_MaxY < Dat[i].y2 *sc) then ZA_MaxY:=Dat[i].y2 *sc;
      end;
   end;

   GREDRAW ;
end;

// j[bݒbF
procedure TFmMain.MnuSetColorClick(Sender: TObject);
var
   i : integer ;
begin
   FmSetColor.ShowModal ;

   if (FmSetColor.OKflag) then begin
      with ComboBox2 do begin
         Items.Clear;
         Items.Add('CF');
         for i:=0 to ColTblN-1 do begin
            Items.Add(ColTbl[i].nam);
         end;
         Items.Add('̑');
         Items.Add('$00000000');
         ItemIndex := 0;
      end;
   end;
   GREDRAW ;
end;

// j[bݒb
procedure TFmMain.MnuSetLStyleClick(Sender: TObject);
var
   i : integer ;
begin
   FmSetLinestyle.ShowModal ;

   with ComboBox3 do begin
      Items.Clear;
      Items.Add('C');
      for i:=0 to LinTblN-1 do begin
         Items.Add(LinTbl[i].nam);
      end;
      ItemIndex := 0;
   end;
   GREDRAW ;
end;

// ========== ========== ========== ==========
//                 {^
// ========== ========== ========== ==========

// XN[o[ňړ
procedure TFmMain.ScrollBar1Change(Sender: TObject);
var
   p : double ;
begin
   p := PA_x/2.0 * ScrollBar1.Position/100.0 ;
   WD_x1 := - SC_x / 2.0 / MM_dot + p ;
   WD_x2 :=   SC_x / 2.0 / MM_dot + p ;
   GREDRAW ;  // ʍč}
end;

// XN[o[ňړ
procedure TFmMain.ScrollBar2Change(Sender: TObject);
var
   p : double ;
begin
   p := - PA_y/2.0 * ScrollBar2.Position/100.0 ;
   WD_y1 := - SC_y / 2.0 / MM_dot + p ;
   WD_y2 :=   SC_y / 2.0 / MM_dot + p ;
   GREDRAW ;  // ʍč}
end;

// }EXŉʈړ
procedure TFmMain.Button10Click(Sender: TObject);
begin
   COM_DISPMOVE;
end;

// }EXłQ{g
procedure TFmMain.Button11Click(Sender: TObject);
begin
   COM_DISPZOOM1 ;
end;

// }EX1/2{k
procedure TFmMain.Button12Click(Sender: TObject);
begin
   COM_DISPZOOM2 ;
end;

// }
procedure TFmMain.Button13Click(Sender: TObject);
begin
   COM_DRAWLINE1 ;
end;

// Fw莞
procedure TFmMain.ComboBox2Click(Sender: TObject);
var
   i : integer ;
begin
   i := ComboBox2.Items.Count ;
   if (ComboBox2.ItemIndex = i-2) then begin
      if (ColorDialog1.Execute) then begin
         ComboBox2.Items[i-1] := '$' + IntToHex(ColorDialog1.Color,8) ;
         ComboBox2.ItemIndex := i-1 ;
      end;
   end;
end;

// ========== ========== ========== ==========
//              R}hڍs
// ========== ========== ========== ==========

// }EXŉʈړ
procedure TFmMain.COM_DISPMOVE ;
begin
   Fmode := 1 ;
   StatusBar1.Panels[0].Text := '}EXʈړ';
   StatusBar1.Panels[1].Text := '';
   StatusBar1.Panels[2].Text := 'ʈړ_wĉ';
end;

// }EXłQ{g
procedure TFmMain.COM_DISPZOOM1 ;
begin
   Fmode := 2 ;
   StatusBar1.Panels[0].Text := '}EXQ{g';
   StatusBar1.Panels[1].Text := '';
   StatusBar1.Panels[2].Text := 'ʒS_wĉ';
end;

// }EX1/2{k
procedure TFmMain.COM_DISPZOOM2 ;
begin
   Fmode := 3 ;
   StatusBar1.Panels[0].Text := '}EX1/2{k';
   StatusBar1.Panels[1].Text := '';
   StatusBar1.Panels[2].Text := 'ʒS_wĉ';
end;

// }
procedure TFmMain.COM_DRAWLINE1 ;
begin
   GRBERASE ;
   Fmode := 100 ;
   StatusBar1.Panels[0].Text := '';
   StatusBar1.Panels[1].Text := 'Q_w';
   StatusBar1.Panels[2].Text := 'Jn_wĉ';
end;

// ========== ========== ========== ==========
//                   L[
// ========== ========== ========== ==========

// L[ĉʈړ
procedure TFmMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if (Key = VK_UP) then begin
      WD_y1 := WD_y1 + IN_move ;
      WD_y2 := WD_y2 + IN_move ;
      GREDRAW ;
      Key := 0 ;
   end
   else if (Key = VK_DOWN) then begin
      WD_y1 := WD_y1 - IN_move ;
      WD_y2 := WD_y2 - IN_move ;
      GREDRAW ;
      Key := 0 ;
   end
   else if (Key = VK_LEFT) then begin
      WD_x1 := WD_x1 - IN_move ;
      WD_x2 := WD_x2 - IN_move ;
      GREDRAW ;
      Key := 0 ;
   end
   else if (Key = VK_RIGHT) then begin
      WD_x1 := WD_x1 + IN_move ;
      WD_x2 := WD_x2 + IN_move ;
      GREDRAW ;
      Key := 0 ;
   end
   else if (Key = VK_HOME) then begin
      WD_x1 := - SC_x / 2.0 / MM_dot ;
      WD_y1 := - SC_y / 2.0 / MM_dot ;
      WD_x2 :=   SC_x / 2.0 / MM_dot ;
      WD_y2 :=   SC_y / 2.0 / MM_dot ;
      GREDRAW ;
      Key := 0 ;
   end;
end;

// ========== ========== ========== ==========
//                 }EX
// ========== ========== ========== ==========

// }EX{^̏
procedure TFmMain.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if (ssLeft in Shift)or(ssRight in Shift) then begin  // NbN
      DRGflag := True ;
      DRGx1 := X ;
      DRGy1 := Y ;
      DRGRBflag := False ;
      DRGx2 := 0 ;
      DRGy2 := 0 ;
      if (ssLeft  in Shift) then DRGx2 := 1 ;
      if (ssRight in Shift) then DRGy2 := 1 ;
   end;
end;

// }EX𓮂
procedure TFmMain.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
   sc,tx,ty : double ;
begin
   sc := LayTbl[ComboBox1.ItemIndex].sc ;
   tx := WD_x1 + X / MM_dot ;
   ty := WD_y2 - Y / MM_dot ;
   LabelA3.Caption := '( '+FloatToStr(tx/sc)+' , '+FloatToStr(ty/sc)+' )';
   //
   if (DRGflag) then begin // EhbO
      if (DRGRBflag) then begin
         GRBBOX(DRGx1,DRGy1,DRGx2,DRGy2);
      end;
      if (ssLeft in Shift)and(ssRight in Shift) then begin
         GRBBOX(DRGx1,DRGy1,X,Y);
         DRGRBflag := True ;
         DRGx2 := X ;
         DRGy2 := Y ;
      end
      else begin
         DRGRBflag := False ;
         if (ssLeft  in Shift) then DRGx2 := 1 ;
         if (ssRight in Shift) then DRGy2 := 1 ;
      end;
   end
   else begin  // }EXړ
      Case (Fmode) of
      101:begin   // bI_w
            GRBERASE ;
            GRBLINE(RBx1,RBy1,X,Y); // Vo[oh`
            RBflag := True ;
            RBx2 := X ;
            RBy2 := Y ;
         end;
      end;
   end;
end;

// }EX{^𗣂̏
procedure TFmMain.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   xx1,yy1,xx2,yy2 : double ;
   cx,cy : double ;
   dx,dy : double ;
   bx,by : double ;
   p1,p2 : Double ;
begin
   if not(DRGRBflag)and((DRGx2 = 0)or(DRGy2 = 0)) then begin
      DRGflag := False ;
      if (DRGx2 = 1) then begin    // NbN
         // NbN
         MouseClick(X,Y,0);
      end
      else if (DRGy2 = 1) then begin    // ENbN
         // Xibv
         MouseClick(X,Y,1);
      end;
      exit;
   end;

   if (DRGflag) then begin
      // hbO
      DRGflag := False ;
      if (DRGRBflag) then begin
         GRBBOX(DRGx1,DRGy1,DRGx2,DRGy2);
      end;
      if (Abs(DRGx1-X) <= 5)and(Abs(DRGy1-Y) <= 5) then
         DRGmode := 0
      else begin
         if (DRGx1 <= X) then begin
            if (DRGy1 <= Y) then
               DRGmode := 1
            else
               DRGmode := 3;
         end
         else begin
            if (DRGy1 <= Y) then
               DRGmode := 4
            else
               DRGmode := 2;
         end;
      end;
      xx1 := WD_x1 + DRGx1 / MM_dot ;
      yy1 := WD_y2 - DRGy1 / MM_dot ;
      xx2 := WD_x1 + X / MM_dot ;
      yy2 := WD_y2 - Y / MM_dot ;
      dx := Abs(WD_x2-WD_x1) ;   // ݂̃r[̑傫
      dy := Abs(WD_y2-WD_y1) ;   // Abs͕KvǈꉞĂ
      bx := Abs(xx1-xx2);  // `̑傫
      by := Abs(yy1-yy2);
      cx := (xx1+xx2)/2.0; // `̒̍W
      cy := (yy1+yy2)/2.0;
      Case (DRGmode) of
      0: begin    // ړ
            cx := (WD_x1+WD_x2)/2.0 ;  // ݂̒̍W
            cy := (WD_y1+WD_y2)/2.0 ;
            dx := xx2 - cx ;      // ړ
            dy := yy2 - cy ;
            WD_x1 := WD_x1 + dx ;      // ړvZ
            WD_y1 := WD_y1 + dy ;
            WD_x2 := WD_x2 + dx ;
            WD_y2 := WD_y2 + dy ;
            GREDRAW ;   // ʍč}
         end;
      1: begin    // g
            if (bx < 0.000001) then bx:=0.000001;
            if (by < 0.000001) then by:=0.000001;
            p1 := dx / bx ;         // ݂̉ʂɑ΂ĉ{H
            p2 := dy / by ;
            if (p1 < p2) then MM_dot := MM_dot*p1 else MM_dot := MM_dot*p2 ;
            WD_x1 := cx - SC_x / 2.0 / MM_dot ;   // r[GAvZ
            WD_y1 := cy - SC_y / 2.0 / MM_dot ;
            WD_x2 := cx + SC_x / 2.0 / MM_dot ;
            WD_y2 := cy + SC_y / 2.0 / MM_dot ;
            GREDRAW ;   // ʍč}
         end;
      2: begin    // k
            p1 := 1.0 - bx / dx ;   // ݂̉ʂ牽{H
            p2 := 1.0 - by / dy ;
            if (p1 > p2) then MM_dot := MM_dot*p1 else MM_dot := MM_dot*p2 ;
            if (MM_dot < MM_dotmax*0.000001) then MM_dot := MM_dotmax*0.000001 ;
            WD_x1 := cx - SC_x / 2.0 / MM_dot ;   // r[GAvZ
            WD_y1 := cy - SC_y / 2.0 / MM_dot ;
            WD_x2 := cx + SC_x / 2.0 / MM_dot ;
            WD_y2 := cy + SC_y / 2.0 / MM_dot ;
            GREDRAW ;   // ʍč}
         end;
      3: begin    // ʕ\
            GALDRAW ;
         end;
      4: begin    // }`S̕\
            if (Dat_N = 0) then
               GALDRAW
            else begin
               bx := Abs(ZA_MaxX-ZA_MinX);  // `̑傫
               by := Abs(ZA_MaxY-ZA_MinY);
               cx := (ZA_MinX+ZA_MaxX)/2.0; // `̒̍W
               cy := (ZA_MinY+ZA_MaxY)/2.0;
               p1 := dx / bx ;         // ݂̉ʂɑ΂ĉ{H
               p2 := dy / by ;
               if (p1 < p2) then MM_dot := MM_dot*p1 else MM_dot := MM_dot*p2 ;
               WD_x1 := cx - SC_x / 2.0 / MM_dot ;   // r[GAvZ
               WD_y1 := cy - SC_y / 2.0 / MM_dot ;
               WD_x2 := cx + SC_x / 2.0 / MM_dot ;
               WD_y2 := cy + SC_y / 2.0 / MM_dot ;
               GREDRAW ;   // ʍč}
            end;
         end;
      end;
   end
end;

// }EXNbN
//    M : 0:NbN 1:ENbNiXibvj
procedure TFmMain.MouseClick(X,Y,M:Integer);
var
   cx,cy : double ;
   tx,ty : double ;
   dx,dy : double ;
   sc : double ;
begin
   cx := (WD_x1+WD_x2)/2.0 ;  // ݂̒̍W
   cy := (WD_y1+WD_y2)/2.0 ;
   dx := Abs(WD_x2-WD_x1) ;   // ݂̃r[̑傫
   dy := Abs(WD_y2-WD_y1) ;   // Abs͕KvǈꉞĂ
   tx := WD_x1 + X / MM_dot ; // NbNW
   ty := WD_y2 - Y / MM_dot ;
   if (M = 1) then begin
      if not(MouseSnap(tx,ty)) then begin
         MessageBeep(Word(-1));
         exit;    // XibvoȂꍇ͉L̏sȂ
      end;
   end;
   Case (Fmode) of
   1: begin // ʈړ
         dx := tx - cx ;      // ړ
         dy := ty - cy ;
         WD_x1 := WD_x1 + dx ;      // ړvZ
         WD_y1 := WD_y1 + dy ;
         WD_x2 := WD_x2 + dx ;
         WD_y2 := WD_y2 + dy ;
         GREDRAW ;   // ʍč}
      end;
   2: begin // Q{g
         MM_dot := MM_dot * 2.0 ;
         WD_x1 := tx - dx/4.0;   // g偁r[1/2ɏȂ
         WD_y1 := ty - dy/4.0;
         WD_x2 := tx + dx/4.0;
         WD_y2 := ty + dy/4.0;
         GREDRAW ;  // ʍč}
      end;
   3: begin // 1/2{k
         MM_dot := MM_dot * 0.5 ;
         WD_x1 := tx - dx;       // kr[1/2ɏȂ
         WD_y1 := ty - dy;
         WD_x2 := tx + dx;
         WD_y2 := ty + dy;
         GREDRAW ;  // ʍč}
      end;
   100:begin // bJn_
         FBx := tx ;
         FBy := ty ;
         Fmode := 101 ;
         StatusBar1.Panels[2].Text := 'I_wĉ';
         RBflag := False ;
         RBx1 := X ;
         RBy1 := Y ;
      end;
   101:begin // bI_
         if (Abs(FBx-tx) > 0.00000001)or(Abs(FBy-ty) > 0.00000001) then begin
            GRBERASE ;
            sc := LayTbl[ComboBox1.ItemIndex].sc ;
            // f[^o^
            Inc(Dat_N);
            try
               SetLength(Dat,Dat_N);   // f[^̈𑝂₷
               DatAttribSet(Dat_N-1);
               Dat[Dat_N-1].x1 := FBx/sc ;   // Y 0 Ȃ̂Œ
               Dat[Dat_N-1].y1 := FBy/sc ;
               Dat[Dat_N-1].x2 := tx /sc ;
               Dat[Dat_N-1].y2 := ty /sc ;
               //
               if (Dat_N = 1) then begin
                  ZA_MinX := Dat[0].x1 *sc;
                  ZA_MinY := Dat[0].y1 *sc;
                  ZA_MaxX := Dat[0].x1 *sc;
                  ZA_MaxY := Dat[0].y1 *sc;
               end;
               if (ZA_MinX > Dat[Dat_N-1].x1 *sc) then ZA_MinX:=Dat[Dat_N-1].x1 *sc;
               if (ZA_MinX > Dat[Dat_N-1].x2 *sc) then ZA_MinX:=Dat[Dat_N-1].x2 *sc;
               if (ZA_MinY > Dat[Dat_N-1].y1 *sc) then ZA_MinY:=Dat[Dat_N-1].y1 *sc;
               if (ZA_MinY > Dat[Dat_N-1].y2 *sc) then ZA_MinY:=Dat[Dat_N-1].y2 *sc;
               if (ZA_MaxX < Dat[Dat_N-1].x1 *sc) then ZA_MaxX:=Dat[Dat_N-1].x1 *sc;
               if (ZA_MaxX < Dat[Dat_N-1].x2 *sc) then ZA_MaxX:=Dat[Dat_N-1].x2 *sc;
               if (ZA_MaxY < Dat[Dat_N-1].y1 *sc) then ZA_MaxY:=Dat[Dat_N-1].y1 *sc;
               if (ZA_MaxY < Dat[Dat_N-1].y2 *sc) then ZA_MaxY:=Dat[Dat_N-1].y2 *sc;
            except
               Dec(Dat_N);
               MessageBeep(Word(-1));
               MessageDlg('ȏf[^o^鎖͏o܂B',
                  mtError, [mbOk], 0);
            end;
            GREDRAW ;   // ʍč}
            Fmode := 100 ;
            StatusBar1.Panels[2].Text := 'Jn_wĉ';
         end;
      end;
   end;
end;

// Xibv
//    ɍ}Ă̒[_T
//    iCɁAԍŏɌt_Ԃj
//    (i/o) x,y : W
//    (ret) False:[_E@True:[_E
function TFmMain.MouseSnap(var x,y:double):Boolean;
const
   AREA = 5;   // }EXwӏ̔F͈(dot)
var
   i,k : integer ;
   a,xx,yy : double ;
begin
   Result := False ;
   if (Dat_N = 0) then exit ; // f[^ꍇ͏I
   a := AREA/MM_dot ;         // }EXwӏ̔F͈(mm)
   for k:=0 to LayTblN-1 do begin
      if (LayTbl[k].cnt = 0) then continue;  // vf=0͎̎̃C
      if not(LayTbl[k].act)  then continue;  // Active͎̎̃C
      for i:=0 to Dat_N-1 do begin
         if (LayTbl[k].no = Dat[i].lay) then begin
            xx := Dat[i].x1 *LayTbl[k].sc ;
            yy := Dat[i].y1 *LayTbl[k].sc ;
            if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
               x := xx;
               y := yy;
               Result := True ;
               break;   // [v𔲂oĒɏI
            end;
            xx := Dat[i].x2 *LayTbl[k].sc ;
            yy := Dat[i].y2 *LayTbl[k].sc ;
            if (Abs(x-xx) <= a)and(Abs(y-yy) <= a) then begin
               x := xx;
               y := yy;
               Result := True ;
               break;   // [v𔲂oĒɏI
            end;
         end;
      end;
      if (Result) then break;
   end;
end;

// }o^ۂɃCo^
//    (inp) n   : o^Dat[]̓Y (0-)
procedure TFmMain.DatAttribSet(n:integer);
var
   i,j,k,k1,k2 : integer ;
   d : double ;
begin
   // C
   i := ComboBox1.ItemIndex ;
   j := LayTbl[i].no ;
   k1:= LayTbl[i].dc ;  // CF
   k2:= LayTbl[i].dl ;  // C
   Dat[n].lay := j ;
   LayTbl[i].cnt := LayTbl[i].cnt + 1 ; // Cݒe[uvfǉ
   // F
   i := ComboBox2.ItemIndex ;
   if (i = 0) then begin
      j := -1;
      if (k1 >= 0) then
         ColTbl[k1].cnt := ColTbl[k1].cnt + 1;   // Fݒe[uvfǉ
   end
   else if (i >= ComboBox2.Items.Count-2) then
      j := -(SInt(ComboBox2.Items[ComboBox2.Items.Count-1]) + 2)
   else begin
      j := i - 1 ;
      ColTbl[i-1].cnt := ColTbl[i-1].cnt + 1;   // Fݒe[uvfǉ
   end;
   Dat[n].col := j ;
   // 
   i := ComboBox3.ItemIndex ;
   if (i = 0) then begin
      j := -1;
      for k:=0 to LinTblN-1 do begin
         if (LinTbl[k].no = k2) then begin
            LinTbl[k].cnt := LinTbl[k].cnt + 1; // ݒe[uvfǉ
            break;
         end;
      end;
   end
   else begin
      j := LinTbl[i-1].no;
      LinTbl[i-1].cnt := LinTbl[i-1].cnt + 1;   // ݒe[uvfǉ
   end;
   Dat[n].lin := j ;
   // 
   if (ComboBox4.Text = 'C') then
      d := -1.0
   else begin
      d := SDbl(ComboBox4.Text);
      if (d <= _LIMITN)or(d > 1000000.0) then begin
         d := 0.0 ;
         ComboBox4.Text := '0';
      end;
   end;
   Dat[n].wid := d ;
end;


end.
